/* Aida Variants -- Generated from: aidaproto.hh xmanifold.py */
# 1 "/opt/src/rapicorn/rcore/aidaproto.hh"
# 1
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R ()> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 0;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  
  
  return func ();
}

} } // Rapicorn::Aida

# 1001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 1;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1;
  fbr >>= a1;
  return func (a1);
}

} } // Rapicorn::Aida

# 2001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 2;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2;
  fbr >>= a1; fbr >>= a2;
  return func (a1, a2);
}

} } // Rapicorn::Aida

# 3001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 3;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3;
  fbr >>= a1; fbr >>= a2; fbr >>= a3;
  return func (a1, a2, a3);
}

} } // Rapicorn::Aida

# 4001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 4;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4;
  return func (a1, a2, a3, a4);
}

} } // Rapicorn::Aida

# 5001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 5;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5;
  return func (a1, a2, a3, a4, a5);
}

} } // Rapicorn::Aida

# 6001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 6;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6;
  return func (a1, a2, a3, a4, a5, a6);
}

} } // Rapicorn::Aida

# 7001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 7;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7;
  return func (a1, a2, a3, a4, a5, a6, a7);
}

} } // Rapicorn::Aida

# 8001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 8;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8;
  return func (a1, a2, a3, a4, a5, a6, a7, a8);
}

} } // Rapicorn::Aida

# 9001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 9;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9);
}

} } // Rapicorn::Aida

# 10001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 10;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
}

} } // Rapicorn::Aida

# 11001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 11;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10; typename ValueType<A11>::T a11;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10; fbr >>= a11;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
}

} } // Rapicorn::Aida

# 12001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11, class A12> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 12;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10; typename ValueType<A11>::T a11; typename ValueType<A12>::T a12;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10; fbr >>= a11; fbr >>= a12;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12);
}

} } // Rapicorn::Aida

# 13001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11, class A12, class A13> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 13;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10; typename ValueType<A11>::T a11; typename ValueType<A12>::T a12; typename ValueType<A13>::T a13;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10; fbr >>= a11; fbr >>= a12; fbr >>= a13;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13);
}

} } // Rapicorn::Aida

# 14001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11, class A12, class A13, class A14> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 14;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10; typename ValueType<A11>::T a11; typename ValueType<A12>::T a12; typename ValueType<A13>::T a13; typename ValueType<A14>::T a14;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10; fbr >>= a11; fbr >>= a12; fbr >>= a13; fbr >>= a14;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14);
}

} } // Rapicorn::Aida

# 15001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11, class A12, class A13, class A14, class A15> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 15;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10; typename ValueType<A11>::T a11; typename ValueType<A12>::T a12; typename ValueType<A13>::T a13; typename ValueType<A14>::T a14; typename ValueType<A15>::T a15;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10; fbr >>= a11; fbr >>= a12; fbr >>= a13; fbr >>= a14; fbr >>= a15;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15);
}

} } // Rapicorn::Aida

# 16001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11, class A12, class A13, class A14, class A15, class A16> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 16;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10; typename ValueType<A11>::T a11; typename ValueType<A12>::T a12; typename ValueType<A13>::T a13; typename ValueType<A14>::T a14; typename ValueType<A15>::T a15; typename ValueType<A16>::T a16;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10; fbr >>= a11; fbr >>= a12; fbr >>= a13; fbr >>= a14; fbr >>= a15; fbr >>= a16;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16);
}

} } // Rapicorn::Aida

# 17001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11, class A12, class A13, class A14, class A15, class A16, class A17> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 17;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10; typename ValueType<A11>::T a11; typename ValueType<A12>::T a12; typename ValueType<A13>::T a13; typename ValueType<A14>::T a14; typename ValueType<A15>::T a15; typename ValueType<A16>::T a16; typename ValueType<A17>::T a17;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10; fbr >>= a11; fbr >>= a12; fbr >>= a13; fbr >>= a14; fbr >>= a15; fbr >>= a16; fbr >>= a17;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17);
}

} } // Rapicorn::Aida

# 18001
// CC0 Public Domain: http://creativecommons.org/publicdomain/zero/1.0/
namespace Rapicorn { namespace Aida {

/// @ingroup AidaManifoldTypes
/// Unpack FieldBuffer as signal arguments and emit() the signal.
template<class R, class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11, class A12, class A13, class A14, class A15, class A16, class A17, class A18> static inline R
field_buffer_emit_signal (const Aida::FieldBuffer &fb, const std::function<R (A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, A12, A13, A14, A15, A16, A17, A18)> &func, uint64 &emit_result_id)
{
  const bool async = !std::is_void<R>::value;
  const size_t NARGS = 18;
  Aida::FieldReader fbr (fb);
  fbr.skip_header();
  fbr.skip();   // skip handler_id
  if (async)
    emit_result_id = fbr.pop_int64();
  if (AIDA_UNLIKELY (fbr.remaining() != NARGS))
    Aida::fatal_error ("invalid number of signal arguments");
  typename ValueType<A1>::T a1; typename ValueType<A2>::T a2; typename ValueType<A3>::T a3; typename ValueType<A4>::T a4; typename ValueType<A5>::T a5; typename ValueType<A6>::T a6; typename ValueType<A7>::T a7; typename ValueType<A8>::T a8; typename ValueType<A9>::T a9; typename ValueType<A10>::T a10; typename ValueType<A11>::T a11; typename ValueType<A12>::T a12; typename ValueType<A13>::T a13; typename ValueType<A14>::T a14; typename ValueType<A15>::T a15; typename ValueType<A16>::T a16; typename ValueType<A17>::T a17; typename ValueType<A18>::T a18;
  fbr >>= a1; fbr >>= a2; fbr >>= a3; fbr >>= a4; fbr >>= a5; fbr >>= a6; fbr >>= a7; fbr >>= a8; fbr >>= a9; fbr >>= a10; fbr >>= a11; fbr >>= a12; fbr >>= a13; fbr >>= a14; fbr >>= a15; fbr >>= a16; fbr >>= a17; fbr >>= a18;
  return func (a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18);
}

} } // Rapicorn::Aida

